<?php

namespace HCM\FPA\Entity;

use HCM\Util\Repositories;
use HCM\Util\TkEntity;
use Zeedhi\Framework\ORM\DateTime;
use Teknisa\Model\Gestaopessoas\Repositories\FpaEventoctbl;

class FpaeventoctblEntity extends TkEntity
{

    const TYPE_DAO = 'D';

    const TYPE_ENTITY = 'E';

    const TYPE_FACADE = 'F';

    const TYPE_LOGIC = 'L';

    const IDVINCATIVO_SIM = 'S';

    const IDVINCATIVO_NAO = 'N';
    
    public function __construct($entityManager, $hcmParameters) {
        $this->hcmParameters = $hcmParameters;
        parent::__construct(null,$entityManager);
    }
    
    public function pesquisaContasContabeis($nr_org, $nr_evento, $nr_estrutura, $dt_competencia, $id_vinculo_ativo, $nr_tp_eventoctbl, $nrTipoMovimento = null) {
        $resultado = $this->entityManager->getRepository(Repositories::FPA_EVENTOCTBL)->retornaContasContabeis(
            $nr_org, $nr_evento, $nr_estrutura, $dt_competencia, $id_vinculo_ativo, $nr_tp_eventoctbl, $nrTipoMovimento
        );
        
        if ($nr_tp_eventoctbl and empty($resultado)) {
            $resultado = $this->entityManager->getRepository(Repositories::FPA_EVENTOCTBL)->retornaContasContabeis(
                $nr_org, $nr_evento, $nr_estrutura, $dt_competencia, $id_vinculo_ativo, $nrTipoMovimento
            );
        }
        
        return current($resultado);
    }
    
    public function getFpaeventoctbl($nrorg, $nreventom, $nrtipomoviment, $nrtpeventoctbl, $nrestruturam, $nreventoctbl = null) {
        $resultado = $this->entityManager->getRepository(Repositories::FPA_EVENTOCTBL)->getFpaeventoctbl(
            $nrorg, $nreventom, $nrtipomoviment, $nrtpeventoctbl, $nrestruturam, $nreventoctbl
        );
        return $resultado;
    } 
}