<?php

namespace HCM\Geral\Entity;
use HCM\Util\TkEntity;
use HCM\Util\Repositories;

class TipohierarqorgEntity extends TkEntity
{
    
    const IDAUTOHIERARQ_NAO = 'N';
    const IDAUTOHIERARQ_SIM = 'S';
    
    public function __construct($entityManager, $hcmParameters){
        
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        parent::__construct(null,$entityManager);
    }
    
    public function retornaTipoHierarquia($nrOrgPadrao, $nr_org, $nr_tipo_hierarquia){
        $resultado = $this->entityManager->getRepository(Repositories::TIPOHIERARQORG)->findBy(array('nrorg' => array($nr_org,$nrOrgPadrao),
            'nrtipohierarqorg' => $nr_tipo_hierarquia));
        return $resultado;
    }

    public function carregaTipoHierarquia($nrOrgPadrao, $nrOrg, $nrTipoHierarquia){
        $resultado = $this->retornaTipoHierarquia($nrOrgPadrao, $nrOrg, $nrTipoHierarquia);
        $this->addItem($resultado);
    }

    public static function getTipoHierarquiaPorEstruturasRelacionadas($nrorg, $nrestruturamrel, $nrestruturamsup)
    {
        $estruturaRelacionada = EstruturamEntity::getEntityByWhere(
            'NRORG = ? AND NRESTRUTURAM = ?', array($nrorg, $nrestruturamrel)
        );
        if (!$estruturaRelacionada) {
            throw new Exception('Estrutura relacionada inválida!');
        }
        $estruturaSuperior = EstruturamEntity::getEntityByWhere(
            'NRORG = ? AND NRESTRUTURAM = ?', array($nrorg, $nrestruturamsup)
        );
        if (!$estruturaSuperior) {
            throw new Exception('Estrutura superior inválida!');
        }
        $tipoHierarqorg = TipohierarqorgEntity::getEntityByWhere(
            '(NRORG = 0 OR NRORG = ?) AND NRTIPOESTRUTREL = ? AND NRTIPOESTRUTSUP = ?',
            array($nrorg, $estruturaRelacionada->getNrtipoestrutura(), $estruturaSuperior->getNrtipoestrutura())
        );
        $nrtipoHierarqorg = $tipoHierarqorg->getNrtipohierarqorg();
        return $nrtipoHierarqorg;
    }
}