<?php
namespace HCM\Geral\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;

class EstadoRepository {

    protected  $connection;
    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection    = $connection;
        $this->entityManager = $entityManager;
    }

    /**
     * @return array
     */
    public function validaRestricaoChavePrimaria($cdPais, $sgestado, $nmestado, $isNew) {
        
        $tpvalidacao;
        if($isNew)
            $tpvalidacao = ' WHERE CDPAIS = :CDPAIS AND (SGESTADO = :SGESTADO OR NMESTADO = :NMESTADO) ';
        else    
            $tpvalidacao = ' WHERE CDPAIS = :CDPAIS AND SGESTADO <> :SGESTADO AND NMESTADO = :NMESTADO ';
        
        $query = "
                SELECT 
                    COUNT(*)
                FROM ESTADO".$tpvalidacao;


        $parameters = 
        [
            "CDPAIS"       => $cdPais,
            "SGESTADO"     => $sgestado,
            "NMESTADO"     => $nmestado,
        ];
        $result = $this->connection->fetchAssoc($query, $parameters);

        if($result['COUNT(*)'] > 0) 
            return true;
        else
            return false;
    }
    
    public function validaExistenciaMunicipio($cdPais, $sgestado) {
        
        $query = "
                SELECT 
                    COUNT(*)
                FROM 
                    MUNICIPIO
                WHERE
                    CDPAIS = :CDPAIS AND SGESTADO = :SGESTADO";

        $parameters = 
        [
            "CDPAIS"    => $cdPais,
            "SGESTADO"  => $sgestado,
        ];
        
        $result = $this->connection->fetchAssoc($query, $parameters);

        if($result['COUNT(*)'] > 0) 
            return true;
        else
            return false;
    }

} 

 